package component.system;
import java.util.Hashtable;

public class TCRPHandler implements MessageHandler, MessageHandlerFactory {
	// reference to the next messagehandler
	private MessageHandler next;
	
	public TCRPHandler(MessageHandler next) {
		this.next = next;
	}
	
	public MessageHandler createMessageHandler(MessageHandler nxtHandler, String componentname) {
		return new TCRPHandler(nxtHandler);
		// here code could be put to automatically read in contracts for the
		// component (this is possible since the name of the component is given
		// as an extra parameter)
	}	
	
	public void handleMessage(Message m) throws Exception {
		// must do nothing special when receiving a message, just execute it
		next.handleMessage(m);
	}
	
	public void sendMessage(Message m) {
		// look at the time now (arrival of message)
		long submitTime = System.currentTimeMillis();
		// check if there is a contract for message m (Contracts is static class)
		TimingContract contract = (TimingContract)Contracts.getContract("TimingContract" + m.getField("Target") + m.getField("Invoke"));
		if (contract == null) System.out.println("No contract found");
		if (contract != null) {
			// MAXENDTIME: stated in contract
			m.putHiddenField("TIMING.MAXENDTIME", new Long(contract.maxEndTime));
			// SUBMITTIME: the time this TCRPHandler receives the message
			// is calculated at the beginning of this message!
			m.putHiddenField("TIMING.SUBMITTIME", new Long(submitTime));
		}
	    next.sendMessage(m);
	}
}