import java.rmi.*;
import java.util.*;

/**
 * The 'LineActor' is an actor which
 * moves a ball over the field, thereby bumping 
 * against any obstacles
 */
public class LineActor
{
   PlayFieldProtocol field;
   int id;
   Random random;
   public LineActor()
     {
	try
	  {
	     field=(PlayFieldProtocol)Naming.lookup("//127.0.0.1/PlayField");
	     id=field.joinActor();
	     random=new Random();
	     run();
	  }
	catch (Exception e)
	  {
	     e.printStackTrace();
	  }
     }
   public void run() throws Exception
     {
	// we start at a random position
	Pos pos = new Pos((id-1)*5,(id-1)*5);
	// the delta is our movement
	// we start going right
	Pos delta = new Pos(1,0);
	for(;;)
	  {
	     // move to the next position
	     Pos newpos = pos.add(delta);
	     // the position is only free
	     // if we can draw a vertical 
	     // line of 10 dots
	     boolean free=true;
	     Pos checkat=newpos;
	     for(int i=0;i<10;i++)
	       {
		  if (!field.isFree(checkat))
		    free=false;
		  checkat=checkat.down();
	       }
	     // if it is not free, we change 
	     // direction
	     if (!free)
	       delta=new Pos(-delta.x,0);
	     else
	       {
		  // if it is free jump to 
		  // the new position
		  checkat=newpos;
		  for(int i=0;i<10;i++)
		    {
		       field.setPosition(checkat,id);
		       checkat=checkat.down();
		    }
		  Thread.sleep(100+random.nextInt(10));
		  // and clear the old 
		  // position
		  checkat=newpos;
		  for(int i=0;i<10;i++)
		    {
		       field.setPosition(checkat,0);
		       checkat=checkat.down();
		    }
		  pos=newpos;
	       }
	  }
     }
   static public void main(String args[])
     {
	new LineActor();
     }
}
