package component.examples.conduit;

class PipeInfo
{
    private int[] pipe;
    private int maxContent;
    private int length;

    public PipeInfo(int length, int maxContent)
    {
	this.length     = length;
	this.maxContent = maxContent;
	pipe = new int[length];
    }

    public int getContent(int i)
    {
	return pipe[i];
    }

    public void setContent(int i, int content)
    {
	pipe[i] = content;
    }

    public int getLength()
    {
	return length;
    }

    public int getMaxContent()
    {
	return maxContent;
    }

    public void update(ConduitUpdateInfo puinfo)
    {
	setContent(puinfo.getCell(), puinfo.getContent());
    }

    public String toString()
    {
	StringBuffer result = new StringBuffer("[");
	for (int i=0; i<pipe.length; i++)
	    {
		result.append(pipe[i]).append(" ");
	    }
	result.append("]");
	return result.toString();
    }
}
