package component.parser;
import component.productions.*;

public class ASTPrimaryPrefix extends SimpleNode 
{
   public ASTPrimaryPrefix(int id) {super(id);}
   public void generateSource()
     {
	SimpleNode c;
	// als we geen children hebben, printen we de fields
	if (children == null || children.length==0)
	  {
	     outputFields("");
	     return;
	  }
	// als het eerste type ResultType is zitten we met een uitzondering
	c=(SimpleNode)children[0];
	if (c instanceof ASTResultType)
	  {
	     childsAndFields();
	     return;
	  }
	// als het een expression is zitten we met een andere uitzondernig
	if (c instanceof ASTExpression)
	  {
	     output("(");
	     generateChildSources();
	     output(")");
	     return;
	  }
	// als het eerste field een "<" of ">" is zitten we met field definitions
	if (fields!=null && fields.length==1)
	  {
	     String s=(String)fields[0];
	     if (s.compareTo("<")==0) output("outmessage.putField(\"");
	     else if (s.compareTo(">")==0) output("outmessage.putHiddenField(\"");
	     ((SimpleNode)children[0]).generateSource();
	     output("\",");
	     ((SimpleNode)children[1]).generateSource();
	     output(")");
	     return;
	  }
	// anders printen we eerst de fields en dan de childs
	fieldsAndChilds();
     }
   
   public Production generateProductions()
     {
	SimpleNode c;
	// als we geen children hebben, printen we de fields
	if (children == null || children.length==0)
	  return sequenceChildProductions();
	// als het eerste type ResultType is zitten we met een uitzondering
	c=(SimpleNode)children[0];
	if (c instanceof ASTResultType)
	  return sequenceChildProductions();
	// als het een expression is zitten we met een andere uitzondernig
	if (c instanceof ASTExpression)
	  return sequenceChildProductions();
	// als het eerste field een "<" of ">" is zitten we met field definitions
	if (fields!=null && fields.length==1)
	  {
	     String s=(String)fields[0];
	     PutFieldProduction res;
	     GetFieldProduction get;
	     Production ap=((SimpleNode)children[1]).sequenceChildProductions();
	     if (s.compareTo("<")==0) res=new PutFieldProduction(null);
	     else if (s.compareTo(">")==0) res=new PutFieldProduction(getCurrentClassName());
	     else res=null;
	     res.setVar((String)((SimpleNode)children[0]).fields[0]);
	     // als de value toevallig direct doorgaat naar een fieldname
	     get=retrieveGetField((SimpleNode)children[1]);
	     if (get==null) res.setVal("*");
	     else res.setVal(get.toString());
	     return Production.sequence(ap,res);
	  }
	// anders printen we eerst de fields en dan de childs
  	return sequenceChildProductions();
     }
}
