package component.parser;
import component.productions.*;

// WVB -- generateproductions is faulty
public class ASTUnmodifiedClassDeclaration extends SimpleNode {
   public ASTUnmodifiedClassDeclaration(int id) {super(id);}
   public void generateSource()
     {
	int i;
	/* introducing sanity checks 
	 * [ OK] 1. componentclass extends component is useless
	 * [ OK] 2. public componentclass is also useless
	 * [ OK] 3. extends component is useless since we should use componentclass
	 * [NOK] 4. extends object is een lacher
	 * [ OK] 5. is the message keyword being used ? (temporary)
	 */
	if (fields.length==2)
	  {
	     /* we are busy with a componentclass */
	     boolean extendsdone=false;
	     output("public class "); output(fields[1]);
	     for(i=0;i<children.length;i++)
	       {
		  SimpleNode c=(SimpleNode)children[i];
		  if (c instanceof ASTName)
		    {
		       /* check (1) */
		       String extendsfrom=c.toString();
		       if ( extendsfrom.compareTo("Component")==0
			  || extendsfrom.compareTo("component.system.Component")==0)
			 {
			    warning("you don't have to inherit from Component when using componentclass");
			 }
		       else 
			 {
			    warning("components extending other components may be faulty");
			 }
		       /* check (2) is done by javac afterwards */
		       output(" extends ");
		       c.generateSource();
		       output("\n");
		       extendsdone=true;
		    }
		  else if (c instanceof ASTNameList)
		    {
		       if (!extendsdone)
			 {
			    output(" extends component.system.Component\n");
			    extendsdone=true;
			 }
		       output(" implements ");
		       c.generateSource();
		       output("\n");
		    }
		  else
		    {
		       if (!extendsdone)
			 {
			    output(" extends component.system.Component\n");
			 }
		       c.generateSource();
		       output("\n");
		       if (!ASTMethodDeclaration.messageused)
			 {
			    warning(" consider using the 'message' keyword");
			 }
		    }
	       }
	  }
	else
	  {
	     output("class "); output(fields[0]);
	     for(i=0;i<children.length;i++)
	       {
		  SimpleNode c=(SimpleNode)children[i];
		  if (c instanceof ASTName)
		    {
		       /* check (3) */
		       String extendsfrom=c.toString();
		       if ( extendsfrom.compareTo("Component")==0
			   || extendsfrom.compareTo("component.system.Component")==0)
			 {
			    warning("use componentclass instead of extends Component");
			 }
		       output(" extends ");
		    }
		  if (c instanceof ASTNameList) output(" implements ");
		  c.generateSource();
		  output("\n");
	       }
	     output("\n");
	  }
     }
   public Production generateProductions()
     {
	int i;
	if (fields.length==2)
	  setCurrentClassName(fields[1]);
	else
	  setCurrentClassName(fields[0]);
	SimpleNode c=(SimpleNode)children[0];
	Production result;
	c=(SimpleNode)children[children.length-1];
	result=c.generateProductions();
	setCurrentClassName(null);
	return result;
     }
}
