package component.productions;

public abstract class Production 
{
   public abstract Production deepCopy(); 
   public static Production deep(Production p)
     {
        if (p==null) return null;
        return p.deepCopy();
     }
   
   protected void fataltry()
     {
	System.out.println("  -- Fatal try statement " + this.getClass());
	System.out.println("  -- please send to werner.van.belle@vub.ac.be");
	System.exit(30);
     }
   
   public abstract Production createTry();
   public static Production createtry(Production p)
     {
	if (p==null) return null;
	return p.createTry();
     }
   
   // [null,null] -> null
   // [null,b] -> b
   // [a,null] -> a
   // [[a,b],c] -> [a,[b,c]] ~ [a,b,c]
   public static Production sequence(Production a, Production b)
     {
        if (a==null) return b;
        if (b==null) return a;
        if (a instanceof AndProduction)
	  {
	     AndProduction A=(AndProduction)a;
	     A.setNext(sequence(A.getNext(),b));
	     return A;
	  }
        return new AndProduction(a,b);
     }
   
   // [null,null] -> null
   // [null,*] -> [*,null]
   // [a,b] -> [a,b]
   // [[a,b],c] -> [a,[b,c]] ~ [a,b,c]
   public static Production choice(Production a, Production b)
     {
	if (a==null && b==null) return null;
	if (a==null) return choice(b,a);
	if (a instanceof OrProduction)
	  {
	     OrProduction A=(OrProduction)a;
	     A.setNext(choice(A.getNext(),b));
	     return A;
	  }
	return new OrProduction(a,b);
     }

   public static Production loop(Production p)
     {
        if (p==null) return null;
        if (p instanceof LoopProduction) return p;
        return new LoopProduction(p);
     }
   
   private static Term getfields=null;
   protected void addGetField(GetFieldProduction p)
     {
	getfields.addField(p.toString(),"*");
     }
   protected Production remangleGetFields()
     {
	fataltry();
	return null;
     }
   public static Production remangleGetFields(Production p)
     {
	Production lhs,rhs;
	if (p==null) return p;
	if (p instanceof ArrowProduction)
	  {
	     getfields=(Term)((ArrowProduction)p).content;
	     rhs=remangleGetFields(((ArrowProduction)p).getNext());
	     lhs=getfields;
	     return new ArrowProduction(lhs,rhs);
	  }
	return p.remangleGetFields();
     }
}
