package component.system;
import java.util.*;

abstract public class AbstractMultiPort 
  extends AbstractPort
{
   protected AbstractPortCreator portcreator;
   protected MessageHandlerCreator handlecreator;
   
   public AbstractMultiPort(String type, Component owner, MessageHandlerCreator m, AbstractPortCreator pc)
     {
	super(type,owner);
	portcreator=pc;
	handlecreator=m;
     }
   
   public void doReceiveMessage(Message m)
     {
	ComponentSystem.Warning("abstractmultiport: receiving message ???");
     }
   protected MessageHandler getMessageHandler(String name)
     {
	return handlecreator.getMessageHandler(name);
     }
   
   static int portnr=0;
   protected AbstractPort getNewPort()
     {
	return (Port)portcreator.createPort(name+(portnr++),owner,getMessageHandler(name));
     }
   abstract public AbstractPort newPort();
   public String toString()
     {
	return super.toString()+"(*)";
     }
}
