package component.system;

public class ComponentTestImplFactory
  extends ComponentImplFactory
{
   public ComponentTestImplFactory()
     {
     }
   public ComponentImpl createComponentImpl(Component c)
     {
	return new ComponentTestImpl(c);
     }
}

class ComponentTestImpl
  extends ComponentImpl
{
   public ComponentTestImpl(Component c)
     {
	super(c);
     }
   public void filterSendMessage(AbstractPort p, Message m)
     {
	synchronized(this)
	  {
	     System.out.print("Enter sending ");
	     super.filterSendMessage(p,m);
	     System.out.println(".");
	  }
     }
   public void filterReceiveMessage(AbstractPort p, Message m)
     {
	synchronized(this)
	  {
	     System.out.print("Enter receiving ");
	     super.filterReceiveMessage(p,m);
	     System.out.println(".");
	  }
     }
}
