package component.system;
import java.util.*;
import java.lang.reflect.*;

public class InvocationMessageHandler
  extends Global
  implements MessageHandler
{
   protected Object invokeonto;
   protected Component component;
   public InvocationMessageHandler(Component c, Object o)
     {
	component=c;
	invokeonto=o;
     }
   public InvocationMessageHandler(Component c)
     {
	component=c;
	invokeonto=c;
     }
   public synchronized void handleMessage(Port P, Message M)
     {
	Method m;
	String methodname=(String)M.getField("Invoke");
	try 
	  {
	     Object args[]=new Object[3];
	     args[0]=P;
	     args[1]=M;
	     args[2]=new Message(M);
	     Class pars[]=new Class[3];
	     pars[0]=Port.class;
	     pars[1]=M.getClass();
	     pars[2]=M.getClass();
	     m=invokeonto.getClass().getMethod(methodname,pars);
	     m.invoke(invokeonto,args);
	  }
	catch (NoSuchMethodException e)
	  {
	     Message m2=new Message();
	     m2.putField("Message",M);
	     m2.putField("Port",P);
	     m2.putField("Invoke","NoSuchMessage");
	     System.out.println("PreWarning: "+component.name+" cannot handle message "+M+"\n" + e);
	     component.system.receiveMessage(m2);
	  }
	catch (InvocationTargetException e)
	  {
	     Fatal("While invoking "+ this +"."+methodname+" an exception occured", e.getTargetException());
	  }
	catch (Exception e)
	  {
	     Fatal("While handling "+ this +"."+methodname+" an exception occured", e);
	  }
     }
}
