package component.system;
import java.lang.reflect.*;
import java.util.*;
import component.system.util.*;

/*
 * WVB --
 *  TODO: containsMessageFor is terrible slow when queues grow... should be 
 *        fixed.
 */
public class MessageQueue
{

   /* there is a data race here: the static variables are changed 	*/
   /* in methods that are synchronized non-static. hence there is	*/
   /* no protection whatsoever for there variables.			*/
   /* does this need to be fixed, or shall we pretend not to mind?	*/
   /* the methods concerned are push(Message) and top()			*/
   static private int messagesdelivered = 0;
   static private int totalqueuedmessages = 0;


   private boolean iswaiting=false;
   private UtilLinkedList ll = new UtilLinkedList();
   
   /**
    * Creates a messagequeue, which can be used to implement a synchronous
    * receive at consumer side and an asynchronous send ad producer side. In
    * other words. The add is asynchrounous and puts a message in the Q,
    * while the pop blocks if there is no message available.
    */
   public MessageQueue()
     {
     }
   
   /*
    * return whether this Queue is waiting for incoming messages or not.
    */
   public boolean isWaiting()
     {
        return iswaiting;
     }
   
   /**
    * returns whether this Queue is empty or not
    */
   public boolean isEmpty()
     {
	return ll.isEmpty();
     }
   
   /**
    * Loop de Q af en check of er message naar target is
    */
   public synchronized boolean containsMessageFor(PortAddress target)
     {
	int s=ll.size(),i;
	for(i=0;i<s;i++)
	  {
	     Message m=(Message)ll.get(i);
	     PortAddress t = m.getTarget();
	     if (t.compareTo(target)==0) return true;
	  }
	return false;
     }
   
   public synchronized void push(Message o)
     {
	totalqueuedmessages++;
	if (totalqueuedmessages % 1000 == 0 )
	  System.out.println("Total messages in queue = "+totalqueuedmessages);
	ll.addLast(o);
	notify();
     }
   
   /**
    * Blocking pop to retrieve the next message on the Q. If the Q is empty
    * this method will block until a message is pushed upon the Q. This method
    * is used to synchronize two threads to each other using a consumer
    * producer like approach.
    */
   public synchronized Message top()
     {
        try
	  {
	     if (ll.isEmpty())
	       {
		  iswaiting=true;
		  wait();
		  iswaiting=false;
	       }
	     return (Message)ll.getFirst();
	  }
	catch(Exception e)
	  {
	     e.printStackTrace();
	  }
	return null;
     }
   public synchronized Message pop()
     {
        try
	  {
	     if (ll.isEmpty())
	       {
		  iswaiting=true;
		  wait();
		  iswaiting=false;
	       }
//	     Message busywith = (Message)ll.getFirst();
	     totalqueuedmessages--;
	     messagesdelivered++;
//	     if (messagesdelivered % 100 == 0)
//	       System.out.println("Messages delivered "+messagesdelivered);
//	     ll.removeFirst();
	     return (Message)ll.removeFirst();
	  }
	catch(Exception e)
	  {
	     e.printStackTrace();
	  }
	return null;
     }
}
