package component.system;
import java.util.*;
import component.system.util.*;
import java.io.Serializable;

public class PortAddress 
  extends Global
  implements UtilComparable, Serializable
{
   protected int nr;
   public PortAddress(int n)
     {
	nr = n;
     }
   public String toString()
     {
	return ""+nr;
     }
   
   public int hashCode()
     {
	return nr;
     }
   public boolean equals(Object o)
     {
	try
	  {
	     if (o == null) return false;
	     if (o instanceof PortAddress)
	       return ((PortAddress)o).nr==nr;
	     return false;
	  }
	catch (Exception e)
	  {
	     Fatal("portaddress: equals wrong type",e);
	  }
	return false;
     }
   public int compareTo(Object o)
     {
	if (o instanceof PortAddress)
	  {
	     if (((PortAddress)o).nr==nr)
	       return 0;
	     else if (((PortAddress)o).nr>nr)
	       return 1;
	     else 
	       return -1;
	  }
	Fatal("portaddress: compareto wrong type");
	return 0;
     }
}
