package component.system;
import java.util.*;

public class SetupPort
  extends AbstractPort
{
   protected boolean valid=true;
   protected String blueprint;
   
   /** 
    * Creation
    */
   public SetupPort(Component owner, String blueprint, String name)
     {
	super(name,owner);
	this.blueprint=blueprint;
     }
   
   void unlink()
     {
	ComponentSystem.Fatal("SetupPort: unlinking of setup port");
     }

   void relink(Component owner)
     {
	ComponentSystem.Fatal("SetupPort: relinking of setup port");
     }

   /**
    * Sending of a message
    */
   public void sendMessage(Message m)
     {
	if (valid)
	  owner.sendCreateComponent(blueprint,name,m);
	else
	  Fatal("sending 2 messages to a setup-port is not allowed. Please make an explicit connections with the component");
	valid=false;
     }
   
   public void doSendMessage(Message m)
     {
	Fatal("setupport: doSendMessage");
     }
   
   /**
    * receival of a message
    */
   public void receiveMessage(Message m)
     {
	Fatal("setupport: receiveMessage");
     }
   public void doReceiveMessage(Message m)
     {
	Fatal("setupport: doReceiveMessage");
     }
   
   /**
    * connection
    */
   public boolean connected()
     {
	return false;
     }
}
