package component.system;
import component.system.util.*;
import java.util.*;

/**
 * This class provides a mapping between the component-names and the
 * components
 */
final class SymbolTable extends Global
{
   final private UtilHashMap map = new UtilHashMap();
   public SymbolTable()
     {
     }
   final public void bind(Object name, Port c)
     {
       if (name==null)
          ComponentSystem.Fatal("bind: name cannot be null "+c,null);
       if (c==null)
          ComponentSystem.Fatal("bind: port cannot be null "+name,null);
       map.put(name, c);
     }
   final public void unbind(String name)
     {
	map.remove(name);
     }
   final public boolean exists(String name)
     {
	return map.containsKey(name);
     }
   final public Port lookup(Object name)
     {
	try 
	  {
	     if (name==null) ComponentSystem.Fatal("Looking up null-name",new Exception());
	     return (Port)map.get(name);
	  }
	catch (ClassCastException e)
	  {
	     Fatal("The thing looking for doesn't seem top be a port");
	     return null;
	  }
     }
}

