package component.system.util;
import component.system.*;
import java.util.Hashtable;
import java.util.Enumeration;

// WVB -- todo
// remove null-key to NULL-key convertie. Keys should not be null anyway
//
public class UtilHashMap
  extends component.system.Global
  implements java.io.Serializable
{
   private Hashtable ht;
   private static final String NULL = "NULL";

   private Object toNULL (Object o)
     {
	if (o == null) return NULL;
	else return o;
     }

   private Object toNull (Object o)
     {
	if (o == NULL) return null;
	else return o;
     }

   public UtilHashMap ()
     {
	ht = new Hashtable ();
     }

   public UtilHashMap (UtilHashMap hm)
     {
	this ();
	this.putAll (hm);
     }

   public void put (Object key, Object value)
     {
	key = toNULL (key);
	if (key == NULL)
	  Fatal("hashmap: setting null key"+key);
	value = toNULL (value);
	ht.put (key, value);
     }

   public Object get (Object key)
     {
	key = toNULL (key);
	if (key == NULL)
	  Fatal("hashmap: getting null key"+key);
	return toNull (ht.get (key));
     }

   public void putAll (UtilHashMap hm)
     {
	Enumeration e = hm.ht.keys();
	while(e.hasMoreElements())
	  {
	     Object key = e.nextElement();
	     Object value = hm.ht.get (key);
	     this.put(key, value);
	  }
	return;
     }
   
   public HashMapIterator keySetIterator()
     {
	return new HashMapIterator(getKeys());
     }
   
   private Enumeration getKeys ()
     {
	return ht.keys (); 
     }
   
   public Object remove (Object key) 
     {
	key = toNULL (key); 
	return toNull (ht.remove (key)); 
     }
   
   public boolean containsKey (Object key) 
     {
	return ht.containsKey (toNULL (key)); 
     }
}
